/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMPrimitive.hh,v $
// $Revision: 1.5 $
// $State: Exp $
// $Author: grlcr $
// $Date: 89/11/27 11:48:51 $
// $Locker:  $
//
// $Log:	XMPrimitive.hh,v $
Revision 1.5  89/11/27  11:48:51  grlcr
1st pass

Revision 1.4  89/11/08  10:38:34  grlcr
*** empty log message ***

Revision 1.3  89/11/03  18:20:55  grlcr
minor reworking

Revision 1.2  89/11/03  09:25:21  grlcr
*** empty log message ***

Revision 1.1  89/11/02  12:32:01  motifplb
Initial revision

// ***** Created Oct 11, 1989 by Krishnan *****
// ***** grlcr: minor changes, Nov 3 *****
//-----------------------------------------------------------------------------
*/

#ifndef XMPrimitive_hh
#define XMPrimitive_hh

#include "XMCore.hh"

class XMPrimitive : public XMCore {
 protected :
     // ****CONSTRUCTORS**** 
     XMPrimitive ();

 public :
     // ****DESTRUCTOR****
     ~XMPrimitive ();

     // ****METHODS TO SET THE Primative RESOURCES****
     void set_bottomShadowColor  (Pixel);
     void set_bottomShadowPixmap (Pixmap);
     void set_foreground         (Pixel);
     void set_entry_helpCallback (XtCallbackProc, caddr_t);
     void set_highlightColor     (Pixel);
     void set_highlightOnEnter   (Boolean);
     void set_highlightPixmap    (Pixmap);
     void set_highlightThickness (short);
     void set_shadowThickness    (short);
     void set_topShadowColor     (Pixel);
     void set_topShadowPixmap    (Pixmap);
     void set_traversalOn        (Boolean);
     void set_unitType           (u_char);
     void set_userData           (caddr_t);

     // ****METHODS TO GET THE Primative RESOURCES****
     void get_bottomShadowColor  (Pixel*);
     void get_bottomShadowPixmap (Pixmap*);
     void get_foreground         (Pixel*);
     void get_highlightColor     (Pixel*);
     void get_highlightOnEnter   (Boolean*);
     void get_highlightPixmap    (Pixmap*);
     void get_highlightThickness (short*);
     void get_shadowThickness    (short*);
     void get_topShadowColor     (Pixel*);
     void get_topShadowPixmap    (Pixmap*);
     void get_traversalOn        (Boolean*);
     void get_unitType           (u_char*);
     void get_userData           (caddr_t*);
};

#endif     // XMPrimitive_hh

// dont add stuff after this endif
